<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, inject, nextTick, onBeforeMount, onMounted, ref, watch } from 'vue';
import { storeToRefs } from 'pinia';
import PersonGridItem from '@/components/chat/PersonsGridItem.vue';
import Tab from '@/components/general/Tab.vue';
import { useAccountStore } from '@/stores/account';
import Input from '@/components/general/form/Input.vue';
import PersonsLengthBadge from '@/components/chat/PersonsLengthBadge.vue';
import { request } from '@/lib/request';
import type { Person } from '@/types/chat';
import { useChatStore } from '@/stores/chat';
import { useI18n } from 'vue-i18n';

const { t } = useI18n();
const $t = t;
const configuration = inject<any>('configuration');

const chatStore = useChatStore();
const accountStore = useAccountStore();
const { mail } = storeToRefs(accountStore);
const { state } = storeToRefs(chatStore);

watch(() => state.value, (newVal, oldVal) => {
    if ((oldVal === 'PERSON_CREATE' || oldVal === 'PERSON_EDIT' || oldVal === 'PERSON_DELETE') && newVal === '') {
        getPersons();
    }
});

const currentTab = ref('all');
const searchTerm = ref('');
const persons = ref<Person[]>([]);
const personsLoaded = ref(false);

const categories = [{ value: 'my', label: $t('ai.person.overview.categories.my.label') }, { value: 'all', label: $t('ai.person.overview.categories.all.label') }].concat(configuration.ai.personCategories);

const handleChangeTab = (tab: string) => {
    currentTab.value = tab;
};

const computedPersons = computed(() => {
    if (currentTab.value === 'my') {
        return persons.value.filter((item) => item.username.toLowerCase() == mail.value.toLowerCase()).filter((item) => item.name.toLowerCase().includes(searchTerm.value.toLowerCase()));
    }
    else if (currentTab.value === 'all') {
        return persons.value.filter((item) => item.name.toLowerCase().includes(searchTerm.value.toLowerCase()));
    }
    else {
        return persons.value.filter((item) => item.categories.findIndex((category: string) => category == currentTab.value) !== -1).filter((item) => item.name.toLowerCase().includes(searchTerm.value.toLowerCase()));
    }
});

const calculatedPersonsLengthPerCategory = (category: string) => {
    if (category === 'my') {
        return persons.value.filter((item) => item.username.toLowerCase() == mail.value.toLowerCase()).filter((item) => item.name.toLowerCase().includes(searchTerm.value.toLowerCase())).length;
    }
    else if (category === 'all') {
        return persons.value.filter((item) => item.name.toLowerCase().includes(searchTerm.value.toLowerCase())).length;
    }
    else {
        return persons.value.filter((item) => item.categories.findIndex((item: string) => item == category) !== -1).filter((item) => item.name.toLowerCase().includes(searchTerm.value.toLowerCase())).length;
    }
};

const tabContainer = ref<HTMLElement>();
const canScrollLeft = ref(false);
const canScrollRight = ref(false);
const handleScrollleft = () => {
    if (tabContainer.value) {
        const newScollLeft = tabContainer.value.scrollLeft - window.innerWidth / 4;
        tabContainer.value.scrollLeft = newScollLeft;
        canScrollLeft.value = newScollLeft > 0;
        canScrollRight.value = newScollLeft + tabContainer.value.clientWidth < tabContainer.value.scrollWidth;

    }
};

const handleScrollRight = () => {
    if (tabContainer.value) {
        const newScrollLeft = tabContainer.value.scrollLeft + window.innerWidth / 4;
        tabContainer.value.scrollLeft = newScrollLeft;
        canScrollLeft.value = newScrollLeft > 0;
        canScrollRight.value = newScrollLeft + tabContainer.value.clientWidth < tabContainer.value.scrollWidth;

    }
};

const getPersons = async () => {
    const result = await request('GET', configuration.apiServer + "/api/ai/person/", undefined, undefined, false, true);
    if (result) {
        persons.value = result.persons.map((person: Person) => { return { name: person.name, description: person.description, uuid: person.uuid, avatar: person.avatar, username: person.username, systemprompt: person.system_prompt, categories: person.categories, model: person.model } });
    };
};

onBeforeMount(async () => {
    await getPersons();
    personsLoaded.value = true;
});

onMounted(async () => {
    nextTick(() => {
        if (tabContainer.value) {
            canScrollLeft.value = tabContainer.value.scrollLeft > 0;
            canScrollRight.value = tabContainer.value.scrollLeft + tabContainer.value.clientWidth < tabContainer.value.scrollWidth;
        }
    });
});


</script>
<template>
    <div class="w-full h-full">
        <div class="mx-auto h-full">
            <div class="flex flex-row gap-4">
                <RouterLink :to="{ name: 'chat-overview' }">
                    <Tooltip :tooltip="$t('ai.overview.backToOverview.label')">
                        <div
                            class="hover:bg-gray-300 rounded-md w-8 h-8 leading-8 align-middle text-center text-gray-500 hover:text-gray-700">
                            <i class="ri-home-2-line ri-lg"></i>
                        </div>
                    </Tooltip>
                </RouterLink>
                <Input :placeholder="$t('ai.person.overview.search.placeholder')" v-model="searchTerm" type="text" />
            </div>
            <div class="flex flex-row select-none">
                <button
                    class="min-w-6 flex flex-col justify-center text-center  hover:bg-gray-300 rounded-md hover:text-gray-700 focus:outline-none focus-within:outline-none"
                    :class="canScrollLeft ? 'text-gray-500' : 'pointer-events-none text-gray-300'"
                    @click="handleScrollleft"><i class="ri-arrow-left-wide-line ri-lg"></i></button>
                <div class="flex flex-row overflow-hidden grow scroll-smooth" ref="tabContainer">
                    <Tab :key="`tab_${index}`" :active="currentTab === item.value"
                        @click="() => handleChangeTab(item.value)" v-for="item, index in categories">
                            <div><span class="mr-1" :class="{'font-bold':currentTab===item.value}">{{ item.label }}</span>
                            <PersonsLengthBadge :count="calculatedPersonsLengthPerCategory(item.value)" /></div>
                    </Tab>
                </div>
                <button
                    class="min-w-6 flex flex-col justify-center text-center hover:bg-gray-300 rounded-md hover:text-gray-700 focus:outline-none focus-within:outline-none"
                    :class="canScrollRight ? 'text-gray-500' : 'pointer-events-none text-gray-300'"
                    @click="handleScrollRight"><i class="ri-arrow-right-wide-line ri-lg"></i></button>
            </div>
            <div class="flex flex-row flex-wrap justify-around gap-2 overflow-auto mt-4 max-h-[calc(100dvh-250px)]">
                <PersonGridItem size="small" :key="`person_${person.name}_${person.categories}`"  :name="person.name"
                    :username="person.username" :uuid="person.uuid" :shared="true" :description="person.description"
                    :categories="person.categories" :systemprompt="person.systemprompt" :avatar="person.avatar" :model="person.model"
                    v-for="person in computedPersons" v-if="computedPersons.length > 0" />
                <div class="text-2xl text-gray-500 mt-8 w-full" v-else>
                    <span v-if="personsLoaded">{{ $t('ai.person.noAvailable.label') }}</span>
                    <div class="rounded-md p-4 max-w-sm w-full mx-auto" v-else>
                        <div class="animate-pulse flex space-x-4">
                            <div class="rounded-full bg-slate-700 h-10 w-10"></div>
                            <div class="flex-1 space-y-6 py-1">
                                <div class="h-2 bg-slate-700 rounded"></div>
                                <div class="space-y-3">
                                    <div class="grid grid-cols-3 gap-4">
                                        <div class="h-2 bg-slate-700 rounded col-span-2"></div>
                                        <div class="h-2 bg-slate-700 rounded col-span-1"></div>
                                    </div>
                                    <div class="h-2 bg-slate-700 rounded"></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>